
	Org	0100
	Jmp	Cherc

Tout	Db	'*.*',0
Chemin	Db	0,':\',80 Dup (0)
NomFic	Db	13 Dup (0)
Msg0	Db	13,10,'Quel est le nom du fichier  trouver ?',13,10,'$'
Msg1	Db	13,10,'Nom de fichier non trouv',13,10,'$'
Msg2	Db	13,10,'Pas de fichier correspondant',13,10,'$'
Msg3	Db	13,10,'Require un DOS version 2.0 ou au dessus',13,10,'$'
Msg4	Db	09,'Y a-t-il une autre recherche ? (O ou N) ','$'
Compte	Dw	0	
Commut	Db	'g'
Repon	Db	14,15 Dup(?)
BpReg	Dw	?
;========================================================================			
Cherc:
	Push	Ds		; Le segment dans la pile
	Xor	Ax, Ax		; Plus un zro dans Ax: adresse retour
	Push	Ax		; A la suite dans la pile pour le retour
	Mov	BpReg, Sp	; Sauvegarde du stack-pointeur
	Mov	Ah, 019		; Recherche de l'unit courante
	Int	021		; Appel au systme pour l'unit
	Add	Al, 'A'		; Conversion en unit
	Mov	Chemin, Al	; Mise en place de l'unit
	Call	Entree		; Appel pour l'entre du nom  trouver
	Jnc	>C1		; Un saut si aucune erreur
	Lea	Dx, Msg1	; Le message d'erreur dans le nom
	Mov	Ah,9		; Le code pour l'affichage
	Int	021		; Appel au DOS pour l'affichage
	Ret			; Fin du programme sur erreur
C1:
	Mov	Ah,030		; Code pour la version du DOS
	Int	021		; Appel au DOS pour la version
	Cmp	Al,2		; Est-ce au moins la version 2 ?
	Jae	>C2		; Ou au dessus, Alors c'est bon
	Lea	Dx, Msg3	; Sinon, adresse du message d'erreur
	Mov	Ah,9	       	; Code pour l'affichage sur l'cran
	Int	021		; Appel  MS-DOS pour cet affichage
	Ret			; Fin du programme sur erreur
C2:
	Lea	Di, Chemin	; L'adresse du chemin dans Di
	Xor	Al,Al		; Zro dans Al (recherche du zro final)
	Cld			; Les incrments dans le bon sens !
	Mov	Cx,64		; Longueur max pour recherche du zro
	Repnz	Scasb		; Lancement de la recherche
	Mov	Bx,Di		; Copie de Di dans Bx
	Dec	Bx		; Ds: Bx pointent sur la fin du chemin
	Mov	Dx,0		; Dx  zro pour la suite
	Call	ChDir		; Appel  la recherche rcursive
	Mov	Ax,Compte	; Toutes les trouvailles dans Ax
	Or	Ax,Ax		; Test de Ax
	Jz	>C3		; Si zro, c'est bon on continue
	Ret			; Sinon, fin de programme
C3:
	Lea	Dx, Msg2	; Ladresse du message "pas trouv"
	Mov	Ah,9		; Le code pour l'affichage sur l'cran
	Int	021		; Appel du DOS pour afficher
	Ret			; Et c'est la fin du programme
Cherc9:
	Mov	Sp, BpReg	; Recupration du stack-pointeur
	Ret			; Fin du programme en catastrophe
;=========================================================================
ChDir:
	Push	Si, Dx		; Sauvegarde des registres Si et Dx
	Lea	Si,NomFic
	Call	Constr		; Pour construire le nom du fichier
	Call	Premier		; Pour voir si on a trouv
	Jc	>C2		; Pas trouv, voir les sous rpertoires
	Call	Ecrire		; Ecrire le nom de la trouvaille
C1:
	Call	Suivant		; Recherche du fichier suivant
	Jc	>C2		; Pas trouv, voir les sous rpertoires
	Call	Ecrire		; Ecrire le nom du fichier
	Jmp	C1		; Chercher le prochain ventuel
C2:
	Pop	Dx		; Restauration de l'adresse
	Push	Dx		; De la Dta
	Lea	Si, Tout	; Tout c'est le "*.*"
	Call	Constr		; Recherche pour tous les rpertoires
	Call	Premier		; D'abord le premier
	Jc	>C5		; Si aucun n'est trouv
	Mov	Si,Dx		; L'adresse de la Dta dans Si
	Test	B [Si+21], 010	; Est-ce un rpertoire ?
	Jnz	>C4		; Oui, alors on cherche les sous-rpertoires
C3:
	Call	Suivant		; Sinon on cherche le suivant
	Jc	>C5		; S'il y en a plus
	Test	B [Si+21], 010	; Est-ce un rpertoire ?
	Jz	C3		; Non, alors suivant
C4:
	Cmp	B [Si+30], '.'	; Est-ce un rpertoire avec . ou .. ?
	Je	C3		; Oui, alors chercher un nouveau
	Call	SouDir		; Sinon chercher un sous-rpertoire
	Push	Ax		; Sauvegarde de la Dta
	Mov	Ah,01A		; Code pour l'affecttation de la Dta
	Int	021		; Appel au DOS pour ce faire
	Pop	Ax		; Rcupration de la Dta
	Jmp	C3		; Suivant, c'est presque sans fin !
C5:
	Pop	Dx, Si		; Rcupration des registres Dx et Si
	Ret			; Avant de retourner vers l'appelant
;========================================================================				
SouDir:
	Push	Di, Si, Ax, Bx
	Cld	      		; Les incrments dans le bon sens
	Mov	Si, Dx		; L'adresse du Nom dans Si
	Add	Si, 30		; Pour le dbut du nom du sous-rpertoire
	Mov	Di,Bx		; DS:Di -- 0  la fin du Chemin
S1:
	Lodsb			; Copie sous-rpertoire vers Chemin
	Stosb			; Copie d'un caractre
	Or	Al,Al		; Est-ce un zro ?
	Jnz	S1		; Non alors on saute la copie
	Mov	Bx,Di		; Bx pointe  la fin du nouveau chemin
	Std			; Les incrments  l'envers !
	Stosb			; Stockage d'un zro
	Mov	Al,'\'		; Un anti-slach dans Al
	Stosb			; Place '\'  la fin du chemin 
	Call	ChDir		; Pour chercher ce nouveau chemin
	Pop	Bx		; Restaure l'ancienne fin de chemin
	Mov	B[Bx],0		; Et stocke un zro ici
	Pop	Ax, Si, Di	; Rcupration des registres
	Ret			; Avant le retour vers l'appelant
;=========================================================================
Ecrire:
	Push	Ax, Dx
	Lea	Dx, Chemin
	Mov	Al,[Bx]			;Save character at end of path
	Mov	B[Bx],0		;Set fOr end of string	
	Call	pasciiz
	Mov	[Bx],Al			;RestOre character
	Pop	Dx			;Recover old poInter
	Push	Dx
	Add	Dx, 30
	Call	pasciiz
	Cmp	b Commut,'g'	
	Je	>E2		
	Push	Dx		
	Lea	Dx, Msg4	
	Mov	Ah,9
	Int	021
	Mov	Ah,7			;read console without echo
	Int	021	
	Or	Al,020			;fold to lower case
	Cmp	Al,'o'			;must be y, anything else exits 
	Je	>E1
	Jmp	Cherc9		;take crash exit
E1:	
	Mov	Dl,Al			;if Y,echo it
	Mov	Ah,2
	Int	021
	Pop	Dx			;restOre poInter to DTA
E2:
	Call	FinLign
	Inc	Compte		;count names displayed
	Pop	Dx, Ax
	Ret
;=========================================================================
Constr:
	Push	Ax, Di
	Mov	Di,Bx
	Cld				;Set direction fOr Increment
C1:
	Lodsb				;Copy one character of name
	Stosb
	Or	Al,Al			;End of string yet?
	Jnz	C1			;No, keep copying
	Pop	Di, Ax
	Ret
;==========================================================================
Premier:
	Push	Cx
	Cmp	Dx,0			;First one?
	Ja	>P1		;No, then allocate space
	Mov	Dx, Tampon-43
P1:
	Add	Dx, 43		;no, then allocate room fOr new DTA
	Mov	Cx,010			;Search attribute fOr files and dirs.
	Mov	Ah,01A			;Set disk transfer Address
	Int	021
	Push	Dx			;Need Dx fOr Address of search name
	Lea	Dx, Chemin
	Mov	Ah,04E			;Call fOr "find first match"
	Int	021
	Pop	Dx, Cx
	Ret				;Return with carry flag info
;=========================================================================	
Suivant:
	Push	Cx, Dx
	Lea	Dx, Chemin
	Mov	Cx,010			;Attribute fOr files and directOries
	Mov	Ah,04F			;Call fOr "Find next match"
	Int	021
	Pop	Dx, Cx
	Ret				;Return with carry flag Intact
;=========================================================================
FinLign:
	Push	Ax, Dx
	Mov	Ah,02
	Mov	Dl,10
	Int	021
	Mov	Dl,13
	Int	021
	Pop	Dx, Ax		; Rcupration du registre Dx	
	Ret
;========================================================================
Pasciiz:
	Push	Ax, Dx, Si
	Cld				;Set direction fOr Increment
	Mov	Si,Dx			;Set up poInter to string
	Mov	Ah,2
P1:
	Lodsb				;Get character
	Or	Al,Al			;if zero,all done
	Jz	>P2
	Mov	Dl,Al
	Int	021			;Write one character
	Jmp	P1		;loop till string exhausted
P2:
	Pop	Si, Dx, Ax
	Ret
;=========================================================================
Entree:
	Lea 	Dx, Msg0
	Mov	Ah, 9
	Int	021
	Lea	Dx, Repon
	Mov	Ah, 10
	Int	021
	Lea	Si, Repon+1
	Lea	Di, NomFic
	Cld
	Lodsb			;any command line present?
	Or	Al,Al		;Return errOr status if not.
	Jz	Entree
E1:         		;scan over leading blanks
	Lodsb			;to file name
	Cmp	Al,13		;if we hit carriage Return
	Jz	>E10	 	;filename is misSing.
	Cmp	Al,020		;is this a blank?
	Jz	E1		;if so keep scanning.
	Xor	Ah,Ah		;reset "." found flag
E2: 			
	Cmp	Al,'\'		;if slash,reset "." flag
	Jne	>E3
	Xor	Ah,Ah
E3:			;check if extenSion specified
	Cmp	Al,'.'
	Jne	>E4
	Inc	Ah
E4:			;
	Stosb			;Move last char. to output
	Lodsb			;check next character, found
	Cmp	Al,13		;carriage Return yet?  	
	Je	Ec8		;yes,exit with success code
	Cmp	Al,'/'		;Or if we hit a Commut delimiter
	Jne	>E6
E5:
	Lodsb			;get the Commut char and save it
	Or	Al,020		;fOrce to lower case
	Mov	byte ptr es:Commut,Al
	Jmp	Ec8		;then jump to finish up
E6:
	Cmp	Al,020		;is this a blank?
	Jne 	E2		;if not keep Moving chars.
E7:
	Lodsb			;search up to end, in case of Commut
	Cmp	Al,'/'
	Je	E5		;found Commut,go save it
	Cmp	Al,13
	Jne	E7		;otherwise, fscan until CR found
Ec8: 				;found end of input name
	Or	Ah,Ah		;was "." found?
	Jnz	>E9		;yes,jump
	Mov	Al,'.'		;no,fOrce ext to wildcard
	Stosb
	Mov	Al,'*'
	Stosb
E9:
	Xor	Al,Al		;stOre trailing null byte
	Stosb			;exit with CY=0 as success flag
	Clc			
	Ret
E10: 	   
	Stc			; Sortie avec retenue pour erreur
	Ret
;==========================================================================
	Even
Tampon:
;==========================================================================
;==========================================================================
