
	Org     0100h		; Samedi 27 Mars 1999
	Jmp     Debut		; Histoire de sauter les donnes

Chemin	Db	'X:\*.*',0,80 Dup (?)
FinChe	Dw	3 + Chemin
Cible	Db	'Cdd.com',0
Msg1	Db	'La liste est trop longue',13,10,024
Tiket	Dw	?
List	Dw	2
FinFic	Dw	0200
Repert	Db	12 Dup (?)
PreSui	Db	0
Niveau	Dw	0
Etoile	Db	"\*.*",0
DtaPtr	Dw	Offset Tampon
DsReg	Dw	?
;============================================================================
Debut:
	Mov	Ax, Cs		; Le segment du programme dans Ax
	Add	Ax, 01000	; Ajoutons-y un segment complet
	Mov	DsReg, Ax	; Et sa sauvegarde
	Mov	Ah, 019	  	; Code pour avoir l'unit en cours
	Int	021		; Appel du DOS pour cette fonction 
	Add	Al, 'A'		; Conversion en lettre d'unit
	Mov	Chemin, Al	; Mise en place de la lettre

;============================================================================
Boucle:
	Mov	Dx, DtaPtr	; L'adresse de la DTA courante
	Mov	Ah, 01A		; Le code pour l'affectation de la DTA
	Int	021		; Grace  un appel au DOS
	Mov	Si, Dx		; Si pointe maintenant vers la DTA
	Cmp	PreSui, 0	; Voir si c'est la premire recherche
	Jnz	>F1		; Sinon chercher le suivant
	Lea	Dx, Chemin	; L'adresse du chemin de recherche
	Mov	Cx, 010		; Attribut pour rpertoires et fichiers
	Mov	Ah, 04E		; Code pour recherche du premier
	Int	021		; Appel du DOS pour cette fonction 
	Jnc	>B1		; Voir s'il a t trouv
	Jmp	AsPlus		; Il y en a plus ?
F1:   
	Mov	Ah, 04F		; Code pour la recherche du suivant
	Int	021		; Appel du DOS pour cette fonction 
	Jc	AsPlus		; Y en a plus ?
B1:
	And	B[Si+21], 010
	Cmp	B[Si+21], 010	; Test: voir si on a un rpertoire
	Jnz	F1		; Sinon on boucle pour le suivant
F2:
	Cmp	B[Si+30], '.'	; Est-ce un rpertoire avec . ou .. 
	Jz	F1		; Si oui, on boucle pour le suivant
	Call	Ecrire		; Appel de l'criveur
	Dec	Di		; Un de moins dans l'index Di
	Mov	FinChe, Di	; Nouvelle fin de la chane asciiz
	Call	EcrEtoile	; L'crivain pour les toiles
	Inc	Niveau		; Nous avons maintenant un niveau de plus
	Mov	PreSui, 0	; Prpare pour la recherche du premier
	Add	DtaPtr, 43	; Nouvelle DTA 
	Jmp	Boucle		; Retour au dbut de la boucle
AsPlus:	
	Cmp	Niveau, 0	; Voir si nous sommes dans la racine
	Jnz	>T1		; Si oui, c'est termin (Pas trop tt)
Fin:
	Call	Copie		; Appel de la copie sur disque
	Int	020		; Fin de programme
T1:
	Call	EcriList	; Appel de celui qui crit la liste
	Lea	Di, Chemin  	; L'adresse de la chane asciiz
	Mov	Cx, 90		; Il peut y avoir 90 caractres
	Mov	Al, 0		; Un zro dans Al pour la recherche
	Repnz   Scasb		; Recherche du zro terminal
	Dec	Di		; Di pointe sur le zro
	Mov	Cx, 64		; On va faire une recherche  l'envers
	Mov	Al, '\'		; Pour trouver un anti-slash
	Std			; Les incrments  l'envers
	Repnz   Scasb		; Recherche un premire fois
	Repnz   Scasb		; Recherche un deuxime fois
	Inc	Di		; Di pointe sur un anti-slash
	Cld			; Les incrments dans le bon sens
	Mov	FinChe, Di	; Nouvelle fin pour la chane asciiz
	Inc	FinChe		; Actuellement un caractre de plus
	Call	EcrEtoile	; L'crivain pour les toiles
	Dec	Niveau		; Nous avons un niveau de moins
	Mov	PreSui, 1	; Nous ne sommes plus  la premire
	Sub	DtaPtr, 43	; La prcdante DTA sera utilise
	Jmp	Boucle		; Boucle principale pour continuer

;============================================================================
EcriList:
	Lea 	Si, Chemin	; L'adresse du chemin
	Mov	Di, List	; La position dans la liste
	Mov	Es, DsReg	; Le segment supplmentaire
T2:
	Lodsb			; Appel d'un caractre
	Stosb			; Stockage d'un caractre
	Cmp	Al, '*'		; Ne pas stocker le \*.*
	Jne	T2		; C'est termin 
	Sub	Di, 2		; Maintenant Di pointe sur '\'
	Sub	Ax, Ax 		; Un zro  la suite dans la liste
	Stosb			; A la suite dans la liste
	Mov	Al, ' '		; Un espace pour l'dition
	Stosb			; A la suite de la liste
	Push	Ds		; Repositionnement du segment
	Pop	Es		; Destination
	Mov	List, Di	; La nouvelle position dans la liste
	Ret			; Fin du sous programme et retour

;======================= Il crit les toiles ===============================
EcrEtoile:
	Lea	Si, Etoile	; C'est la chane \*.*, 0
	Mov	Cx, 5		; Il y a seulement 5 caractres
	Rep	Movsb		; Dplacement du total d'un coup
	Ret			; Fin de sous programme et retour

;====================== L'crivain de tout ==================================
Ecrire:
	Push	Si		; Sauvegarde du registre Si
	Sub	Cx, Cx		; Le compteur  zro
	Add	Si, 30		; Si pointe sur le nom dans la DTA	
	Mov	Di, FinChe	; Fin de la recherche courante
	Cmp	B[Di-1], '\'	; Y a-t'il dj un anti-slash ?
	Je	>B2		; Si oui, c'est bien plus simple
	Mov	B[Di], '\'	; Un anti-slash  la suite du nom
	Inc	Di		; Et sa prise en compte dans l'index
	Inc	FinChe		; Comme dans la fin du chemin
B2:  
	Lodsb			; Appel d'un caractre du nom
	Stosb			; Stokage  sa place
	Or	 Al, Al		; Est-ce le zro final ?
	Jz	 >C3		; Si oui, c'est fini, sortie de boucle
	Loop	B2		; Boucle pour tous les caractres du nom
C3:
	Pop	Si		; Rcupration de l'index Si
	Ret			; Fin de sous programme et retour
;============================================================================
Copie:
	Mov	Ax, 0FFFF	; 0FFFF dans Ax
	Sub	Ax, FinFic	; Moins la longueur de CDD.com
	Sub	Ax, 32		; Moins 32 pour la pile
	Cmp	Ax, List	; Vrification de la liste
	Jb	>C1		; Domage! on ne peut pas crire la liste
	Mov	Ax, 03D02	; Code pour l'ouverture d'un fichier
	Lea	Dx, Cible	; L'adresse du nom du fichier
	Int	021		; Appel du DOS pour cette fonction  
	Mov	Tiket, Ax	; Sauvegarde du tiket
	Mov	Bx, Ax		; Le tiket dans Bx
	Mov	Ax, 04200	; Code pour le dplacement du pointeur
	Sub	Cx,Cx		; Les poids fort du dplacement
	Mov	Dx, FinFic	; En fin de fichier
	Int	021		; Appel du DOS pour cette fonction   
	Mov	Bx, Tiket	; Rappel du tiket dans Bx
	Mov	Ah, 040		; Code pour l'criture sur disque
	Mov	Cx, List	; Le nombre d'octets  crire
	Sub	Dx, Dx		; Dx pointe au dbut du segment
	Mov	Di, Dx		; Il me faut un pointeur
	Mov	Ds, DsReg	; Le changement de segment
	Mov	Ds:[Di], Cx	; Le nombre d'octets en tte de liste
	Int	021		; Appel du DOS pour cette fonction
	Push	Es		; Remise  jour du segment
	Pop	Ds		; Modifi pour un grand tampon
	Mov	Ah, 03E		; Le code de fermeture de fichier
	Int	021	        ; Appel du DOS pour cette fonction  
	Ret			; Fin du sous programme et retour
C1:
	Lea     Dx, Msg1	; L'adresse du message trop long
	Mov	Ah, 9		; Le code pour l'affichage
        Int     021             ; Appel du DOS pour cette fonction   
	Ret			; Fin de sous programme et retour 							 

;========================== Le Tampon de lecture ============================
	Even
Tampon:
;============================================================================

