; Ce programme commute les accents de DOS vers WINDOWS et vic versa.
; Le sens de la commutation est dtermin automatiquement.
; Dvelopp par Janot Jamet,   6,Rue Jacques Prvert,   42160 BONSON France

	Org		0100
	Jmp		Debut

Source	Db  64,?,64 Dup (?)	; Pour le nom du fichier  traiter
Cible	Db  64,?,64 Dup (?)	; Pour le nom du fichier trait
Tk_Cbl	Dw  ?			; Le ticket de la cible
Tk_Src	Dw  ?			; Le ticket de la source

Acueil  Db  10,10,201,15 Dup (205),187,13,10,
	Db   186,' Bonjour toi ! ',186,13,10,
        Db  200,15 Dup (205),188,10,10,13,'$'

Nm_Cbl	Db  10,10,201,58 Dup (205),187,13,10,
	Db  186,' Quel est le nom et le chemin complet du fichier ',
	Db  'trait ? ',186,13,10,
	Db  200,58 Dup (205),188,13,10,'$'

Nm_Src  Db  10,10,201,61 Dup (205),187,13,10,
	Db  186,' Quel est le nom et le chemin complet du fichier ',
	Db  ' traiter ? ',186,13,10,
        Db  200,61 Dup (205),188,10,13,'$'

Er_Mess	Db  'Ce fichier est introuvable! Rveilles-toi !',13,10,'$'
Er_Cre	Db  'Ce nom de fichier ne convient pas.',13,10,'$'
Taille	Dw  52220
Reste	Dw  ?
Filtre	Dw  F_Dos

Windows	Db  199,252,233,226,228,224,225,231,234,235,232,239,238,236,
	Db  196,197,201,230,198,244,246,242,251,249,255,214,220,162,
	Db  163,165,80,131,225,233,243,250,241,209

Dos	Db  041,041,041,041,08e,08f,092,080,045,045,045,045,049,049
	Db  049,049,044,0a5,04f,04f,04f,04f,099,078,0ed,097,0a3,055,
	Db  09a,079,0e8,0e1,085,0a0,083,061,084,061,091,087,08a,082,
	Db  088,089,08d,0a1,08c,08b,0eb,0a4,095,0a2,093,06f,094,0f6,
	Db  0e9,097,0a3,096,081,079,0e8,098

;-------------------------------------------------------------------------
Debut:
	Lea	Dx, Acueil	; Le message "Bonjour"
	Mov	Ah, 09		; Le code pour afficher sur l'cran
	Int	021		; Appel au systme pour ce code
A1:
	Call	Nommer		; Appel demandant les noms des fichiers
	Call	Creer		; Appel de la routine Creer
	Jc	A1		; Si le nom n'est pas correct
	Call	Ouvrir		; Appel pour ouverture de la source
	Jc	A1		; Si un fichier n'existe pas refaire
A2:
	Call	Lire		; Lecture du fichier dans le tampon
	Call	Lequel		; Quel est le texte entr ?
	Call	Filtre		; Traitement du fichier selon son origine
	Call	Ecrire		; Ecriture sur disque aprs traitement
	Cmp	Reste, 52220	; Reste-t-il encore des octets  lire ?
	Je	A2		; Si oui, on continue
	Call	Fermer

	Mov	Ah, 04C		; Code pour la fin du programme
	Int	021		; Appel au systme pour ce code

;-------------------------------------------------------------------------
Nommer:
	Lea	Dx, Nm_Src	; Le message nom du fichier  traiter
	Mov	Ah, 09		; Le code pour afficher sur l'cran
	Int	021		; Appel au systme pour ce code
	Lea	Dx, Source	; Le tampon pour le nom du source
	Mov	Ah, 0A		; Le code pour une lecture au clavier
	Int	021		; Appel au systme pour ce code
	Mov	Ax, Bx, 0	; Un petit zro dans Bx et Ax
	Mov	Si, Dx		; L'adresse du nom dans l'index Si
	Cmp	B [Si+1], 0	; A-t-on entr quelque chose ?
	Je	Nommer		; Si non on va recommencer
	Mov	Bl, [Si+1]	; Le nombre de caractres entrs
	Mov	[Bx+Si+2], Al	; Un zro terminal pour le nom
N1:
	Lea	Dx, Nm_Cbl	; Le message nom du fichier  traiter
	Mov	Ah, 09		; Le code pour afficher sur l'cran
	Int	021		; Appel au systme pour ce code
	Lea	Dx, Cible	; Le tampon pour le nom du source
	Mov	Ah, 0A		; Le code pour une lecture au clavier
	Int	021		; Appel au systme pour ce code
	Mov	Ax, Bx, 0	; Un petit zro dans Bx et Ax
	Mov	Si, Dx		; L'adresse du nom dans l'index Si
	Cmp	B [Si+1], 0	; A-t-on entr quelque chose ?
	Je	N1		; Si non on va recommencer
	Mov	Bl, [Si+1]	; Le nombre d'octets dans Bl
	Mov	[Bx+Si+2], Al	; Un zro terminal pour le nom
	Ret			; Retour vers l'appelant
E1:
	Mov	Ah, 9		; Le code d'affichage sur l'cran
	Lea	Dx, Er_Cre	; Le message d'erreur en cration
	Int	021		; Appel au s6M pour afficher
	Ret			; Retour vers l'appelant

;-------------------------------------------------------------------------
Creer:
	Lea	Dx, Cible+2	; L'adresse du nom du fichier
	Xor	Cx, Cx		; En lecture et criture
	Mov	Ax, 03c00	; Le code pour la cration d'un fichier
	Int	021		; Appel au DOS pour ce code
	Jc	>C1		; Au cas ou il y aurait une erreur
	Ret			; Retour vers l'appelant
C1:
	Mov	Ah, 9		; Le code pour affichage
	Lea	Dx, Er_Cre	; L'adresse du message d'erreur
	Int	021		; Appel au DOS pour afficher
	Stc			; Positionnement de la retenue
	Ret			; C'est fini, retour
	
;-------------------------------------------------------------------------
Ouvrir:
	Lea	Dx, Source+2	; Le nom de fichier source
	Mov	Ax, 03D00	; Le code ouverture en lecture
	Int	021		; Appel au systme pour ouvrir
	Jc	>E1		; Le fichier n'existe pas
	Mov	Tk_Src, Ax	; Le tiket du source
	Lea	Dx, Cible+2	; Le nom du fichier cible
	Mov	Ax, 03D01	; Le code ouverture en criture
	Int	021		; Appel au systme pour l'ouverture
	Jc	>E1		; Le fichier n'est pas trouv
	Mov	Tk_Cbl, Ax	; Le tiket de la cible		
	Ret			; Retour, pas trop tot !
E1:
	Lea	Dx, Er_Mess	; L'adresse du message d'erreur
	Mov	Ah, 9		; Code pour afficher sur l'cran
	Int	021		; Appel au systme pour afficher
	Ret			; Retour  l'appelant, ouf !

;-------------------------------------------------------------------------
Lire:
	Mov	Bx, Tk_Src	; Le tiket du source dans Bx
	Mov	Cx, Taille	; Le nombre d'octets  lire
	Mov	Dx, Tampon	; L'adresse du tampon d'criture
	Mov	Ah, 03F		; Le code pour la lecture sur disque
	Int	021		; Appel au systme pour la lecture
	Mov	Reste, Ax	; C'est ce qui a t lu
	Ret			; Et retour vers l'appelant

;-------------------------------------------------------------------------
Lequel:
	Mov	Si, Di, Tampon	; L'adresse du tampon dans Si et Di
	Mov	Cx, Reste	; Le nombre de caractres
	Mov	Al, 0e9		; C'est le "" de windows
	Repne	Scasb		; Recherche du "" dans le source
	Jcxz	>L1		; Si non trouv on permute
	Je	Ret		; Bravo trouv !
L1:
	Mov	Ax, F_Win	; Il faut aussi permuter les
	Mov	Filtre, Ax	; Routines de traduction
	Ret			; Fin de routine et retour

;-------------------------------------------------------------------------
F_Dos:
	Mov	Si, Di, Tampon	; L'adresse du tampon dans Si, Di
	Mov	Cx, Reste	; Le nombre de caractres dans Cx
	Lea	Bx, Dos		; La table de caractres accentu+s
	Mov	Ax,0		; Pour forcer Ah  zro
R1:
	Lodsb			; Appel d'un caractre dans Al
	Cmp	Al, 192		; Est-ce dans le domaine accents ?
	Jb	>R2		; Non, Alors on va stoker
	Sub	Al, 192		; Calcul du dplacement en Table
	Xlat			; Traduction des accents
R2:
	Stosb			; Stokage du caractre trait ou non
	Loop	R1		; Bouclons pour tous les caractres
	Ret			; Fin de routine et retour

;-------------------------------------------------------------------------
F_Win:
	Mov	Si, Di, Tampon	; L'adresse du tampon dans Si, Di
	Mov	Cx, Reste	; Le nombre de caractres dans Cx
	Lea	Bx, Windows	; La table de caractres accentus
	Mov	Ax,0		; Pour forcer Ah  zro
S1:
	Lodsb                   ; Appel du premier caractre
	Cmp	Al, 080		; Est-on dans la zone des accents ?
	Jb	>S2		; Si non on ne fait rien
	Cmp	Al, 0a5		; Sommes-nous en dehors des accents ?
	Jg	>S2		; On ne fait toujours rien
	Sub	Al, 080		; Soustraction de l'origine
	Xlat			; Translation des accents
S2:
	Stosb			; Stokage du caractre dans le tampon
	Loop	S1		; On boucle pour tous les caractres
	Ret			; Fin de routine et retour

;-------------------------------------------------------------------------
Ecrire:
	Mov	Bx, Tk_Cbl	; Le tiket du fichier cible
	Mov	Cx, Reste	; Le nombre d'octets  crire
	Mov	Dx, Tampon	; L'adresse du tampon d'criture
	Mov	Ah, 040		; Le code pour l'criture sur le disque
	Int	021		; Toujours l'appel  msdos
	Ret			; Fin de routine et retour

;-------------------------------------------------------------------------
Fermer:
	Mov	Ah, 03E
	Mov	Bx, Tk_Cbl
	Int	021
	Mov	Bx, Tk_Src
	Int	021
	Ret

;==========================================================================
	Even 16			; Histoire de s'aligner
Tampon:				; La zone mmoire pour la lecture
;==========================================================================
